// 初始化链接
Vue.prototype.baseurl = 'http://mr.wh68.wanheweb.com/api'
Vue.prototype.imgurl = 'http://mr.wh68.wanheweb.com/'
// Vue.prototype.imgurls = 'http://jq.wh66.cn/'


// 发送事件
Vue.prototype.sends = function (name, param) {
    api.sendEvent({
        name: name,
        extra: param
    })
}

//接受事件
Vue.prototype.addEventListener = function (name, callback) {
    api.addEventListener({
        name: name
    }, function(ret, err) {
        callback(ret)
    });
}


// 加载UI
Vue.prototype.shows = function (title, text) {
    var title = title || '努力加载中...'
    api.showProgress({
        title: title,
        text: text,
        modal: false
    })
}
Vue.prototype.hides = function () {
    api.hideProgress()
}
Vue.prototype.toast = function (msg) {
    if (!msg) {
        return
    }
    api.toast({
        msg: msg,
        duration: 3000,
        location: 'middle'
    });
}


// ajax封装
Vue.prototype.ajax = function (options, callback) {
    var token = window.localStorage.getItem('token')
    var self = this
    self.shows()
    // 获取token  获取url  获取data  获取type
    var data = options.data || {}
    var type = options.type || 'POST'
    var url = this.baseurl + options.url
    callback = callback || function () {}

    $.ajax({
        url: url,
        type: type,
        data: data,
        dataType: 'JSON',
        headers: {
            token: token
        },
        success: function (res) {
            console.log(JSON.stringify(res))
            if (res.errcode == 0) {
                callback(res)
            }else if(res.errcode =='4000'){
                self.toast('网络错误')
            }else{
                self.toast(res.errmsg)
            }
            self.hides()
        },
        error: function (err) {
            self.toast('网络超时，请稍后重试...')
            self.hides()
            console.log(JSON.stringify(err))
        },
        complete: function () {
            self.hides()
        }
    })
}


//手机号码验证
Vue.prototype.iphoneBlur=function (phone) {
    var _this = this
    // 手机号码验证
    // var iphoneNumber = phone
    var iphoneisTrue = _this.iPoneVerification(phone)
    // console.log(iphoneisTrue)
    if (!iphoneisTrue) {
        _this.bdTTSs('请填写有效的11位手机号码')
      toast('请填写有效的11位手机号码')
      return false
    }
  },

  Vue.prototype.iPoneVerification=function (res) {
    // 手机号码正则
    var regular = /^[1][3,4,5,7,8,9,6][0-9]{9}$/
    return regular.test(res)
  },

  Vue.prototype.sixCode=function (code) {
    var verCodeisTrue = code.length == 6
    if (!verCodeisTrue) {
      return false
    }
  },

  Vue.prototype.registerPassword = function(password) {
    var reg = /^(?![0-9]+$)(?![a-zA-Z]+$)[0-9A-Za-z]{6,12}$/
    if (!reg.test(password)) {
       return false
    } else {
      return true
    }
  }

// 扫一扫
Vue.prototype.saoma = function (callback) {
    var FNScanner = api.require('FNScanner');
    FNScanner.openScanner({
        autorotation: true
    }, function (ret, err) {
        if (ret.content == 1) {
            callback()
        }
    })
}


// 下拉加载
Vue.prototype.getMore=function(callback) {
    api.setRefreshHeaderInfo({
        loadingImg: '',
        bgColor: '#fff',
        textColor: '#ccc',
        textDown: '下拉刷新...',
        textUp: '松开刷新...'
    }, function(ret, err) {
        callback()
    });
}

// 关闭下拉加载
Vue.prototype.closeMore=function() {
    api.refreshHeaderLoadDone()
}

//上拉加载
Vue.prototype.upMore = function(callback){
    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 50
        }
    },function() {
        callback()
    })
}

// 关闭上拉加载
Vue.prototype.closeUpMore=function() {
    api.removeEventListener({
        name: 'scrolltobottom'
    });
}



// 定时时间
Vue.prototype.time=function(time,callback) {
    time=time || 1000
    setTimeout(() => {
        callback()
    }, time);
}


// 初始极光推送
Vue.prototype.sendPush = function (tel) {
    var ajpush = api.require('ajpush');
    var param = {
        alias: tel
    };
    ajpush.bindAliasAndTags(param, function (ret) {
        // 绑定成功
        var statusCode = ret.statusCode;
    })
}

// 禁止极光推送
Vue.prototype.stopPush = function () {
    var ajpush = api.require('ajpush');
    ajpush.stopPush(function (ret) {
        if (ret && ret.status) {
            // 停止推送
        }
    });
}


// 时间更新
Vue.filter('timechange', function (value) {
    var time = new Date(value * 1000)
    var year = time.getFullYear()
    var mouth = time.getMonth() + 1
    var day = time.getDate()

    function addzero(value) {
        if (value < 10) {
            return '0' + value
        } else {
            return value
        }
    }
    value = addzero(year) + '-' + addzero(mouth) + '-' + addzero(day)
    return value
})
// times
Vue.filter('timechange', function (value) {
    var time = new Date(value * 1000)
    var year = time.getFullYear()
    var mouth = time.getMonth() + 1
    var day = time.getDate()
    var hours = time.getHours()
    var getMinutes = time.getMinutes()

    function addzero(value) {
        if (value < 10) {
            return '0' + value
        } else {
            return value
        }
    }
    value = year + '-' +addzero(mouth) + '-' + addzero(day) + ' ' + addzero(hours) + ':' + addzero(getMinutes)
    return value
})

//时间倒计时

Vue.prototype.timeDown =function(endTimes) {
    const endTime = new Date(endTimes)
    const nowTime = new Date();
    let leftTime = parseInt((endTime.getTime()-nowTime.getTime())/1000)
    let d = parseInt(leftTime/(24*60*60))
    let h = parseInt(leftTime/(60*60)%24)
    let m = parseInt(leftTime/60%60)
    let s = parseInt(leftTime%60)
    return `${h}小时${m}分${s}秒`     // 需要修改时间样式的话 ，比如需要什么30分钟倒计时，就只保留分和秒
}


Vue.prototype.setIntvals = function(times){
    var self = this
    setInterval(function(){
        self.timeDown(times)
      },500)
}

//下拉刷新
//接受事件
Vue.prototype.addEventListenerUp = function (name, callback) {
    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 50
        }
    }, function(ret, err) {
        callback(ret)
    });
}

//定位
Vue.prototype.getlocation = function(callback, callbackerr) {
    var _this = this
    var bMap = api.require('bMap')
    bMap.getLocation({
        accuracy: '10m',
        autoStop: true,
        filter: 1
    }, function(ret, err) {
        if (ret.status) {
            var map = api.require('bMap')
            map.getNameFromCoords({
                lon: ret.lon,
                lat: ret.lat
            }, function(ret, err) {
                console.log(JSON.stringify(ret))
                if (ret.status) {
                    $api.setStorage('home_lon', ret.lon)
                    $api.setStorage('home_lot', ret.lat)
                    $api.setStorage('home_city', ret.city)
                        // _this.city = ret.city
                        // _this.xinyuanAjax()
                    callback(ret.city, ret)
                }
            })
        } else {
            toast('获取定位失败')
            _this.bdTTSs('获取定位失败,请开启定位')
                // _this.city = '全国'
            callbackerr()
                // _this.xinyuanAjax()
        }
    })
}

//根据定位获取天气
Vue.prototype.getlocationWeather = function(location, callback) {
    var self = this
    // $.ajax({
    //     url: 'http://api.map.baidu.com/telematics/v3/weather',
    //     type: 'post',
    //     data: {
    //         location: location,
    //         output:'json',
    //         ak:'XqphUMw8pVcDk0Rc0uQEH4ESHCiRFYbD'
    //     }
    // }, function(res,err) {
    //     console.log(JSON.stringify(err))
    //     if(res){
    //         callback(res)
    //     }
    // })

    $.ajax({
        url: 'http://api.map.baidu.com/telematics/v3/weather?location='+location+'&output=json&ak=XqphUMw8pVcDk0Rc0uQEH4ESHCiRFYbD',
        type: 'get',
        dataType: 'JSON',
        success: function(res) {
            console.log(JSON.stringify(res))
            if(res.status == 'success'){
                callback(res)
            }

        },

        error:function(err){
            console.log(err+'获取失败')
        }
    })
}

//语音合成
Vue.prototype.bdTTSs = function(content,callback) {
    var bdTTS = api.require('bdTTS');
    bdTTS.init({
        mode:'MIX'
    },function(ret){
        bdTTS.speak({
            text:content
        },function(rets){
            if(rets.status){
                if(callback){
                    callback();
                }
                
            }
        });
    });
}
