Vue.prototype.baseurl = 'http://mr.wh68.wanheweb.com'
Vue.prototype.shows = function (title, text) {
    var title = title || '努力加载中...'
    api.showProgress({
        title: title,
        text: text,
        modal: false
    })
}
Vue.prototype.hides = function () {
    api.hideProgress()
}
Vue.prototype.toast = function (msg) {
    if (!msg) {
        return
    }
    api.toast({
        msg: msg,
        duration: 3000,
        location: 'middle'
    });
}
Vue.prototype.ajax = function (options, callback) {
    var _this = this;
    var token = window.localStorage.getItem('token');
    var self = this;
    self.shows()

    // 获取token  获取url  获取data  获取type
    var data = options.data || {}
    // console.log(JSON.stringify(data))
    var type = options.type || 'GET';
    var url = this.baseurl + options.url
    callback = callback || function () {}
    $.ajax({
        url: url,
        type: type,
        data: data,
        dataType: 'JSON',
        success: function (res) {
            // alert(JSON.stringify(res))
            console.log(token)
            if (res.errcode == 0) {
                console.log(JSON.stringify(res))
                callback(res)
            } else {
                if(res.errmsg == 'token 不能为空'){
                    _this.openW('login');
                }else{
                    self.toast(res.errmsg)
                }
            }
            self.hides()
        },
        error: function (err) {
            console.log(JSON.stringify(err))
            self.toast('网络超时，请稍后重试...')
            self.hides()
        },
        complete: function () {
            self.hides()
        }
    })
}
